#!/bin/sh

#
#Must be executed as root
#

FP_DIR=`pwd`
patch=patch.tar

usage()
{
echo "Usage: $0 DataMart-install-dir
DataMart-install-dir is the directory where the DataMart is installed
"
        return 0
}

File_List()
{
# List of ifixes
#
cd patch
PFILE_LIST=`ls`
cd ..
}

action()
{
cd patch
for PFILE in ${PFILE_LIST}
do
if [ "$PFILE" = "libcOracle.so" ]
  then SUBDIR="lib"
fi
if [ "$PFILE" = "libtclOracle.so" ]
  then SUBDIR="lib"
fi

GROUP=`ls -g $DLDIR/version | awk '{print $3}'`
USER=`ls -l $DLDIR/version | awk '{print $3}'`

if [ -f "$DLDIR/$SUBDIR/$PFILE.old" ]
 then
     rm $DLDIR/$SUBDIR/$PFILE.old
fi

echo "Updating $DLDIR/$SUBDIR/$PFILE"
if [ -f "$DLDIR/$SUBDIR/$PFILE" ]
 then
mv $DLDIR/$SUBDIR/$PFILE $DLDIR/$SUBDIR/$PFILE.old
fi

cp $PFILE $DLDIR/$SUBDIR/$PFILE
chown $USER $DLDIR/$SUBDIR/$PFILE
chgrp $GROUP $DLDIR/$SUBDIR/$PFILE
chmod 551 $DLDIR/$SUBDIR/$PFILE

done
cd ..

}

unpack_files()
{
        tar -xf $patch
}

cleanup_files()
{
        rm -rf "$FP_DIR/patch"  && return 0
        echo "Could not remove $FP_DIR/patch" && return 1
}

DLDIR="$1"
[ -z "$DLDIR" ] && usage && exit 1

echo "Unpacking..." && unpack_files || exit 1

echo "Gathering file info..." && File_List

echo "Installing..." && action

echo "Cleaning up..." && cleanup_files || exit 1

echo "Success."

exit 0
